Update Red Hat Copyright Notices
[nbdkit.git] / tests / test-retry-reopen-fail.sh
blob5f332e0246a2501e6c6595f5a7be748b8eb10643
1 #!/usr/bin/env bash
2 # nbdkit
3 # Copyright Red Hat
5 # Redistribution and use in source and binary forms, with or without
6 # modification, are permitted provided that the following conditions are
7 # met:
9 # * Redistributions of source code must retain the above copyright
10 # notice, this list of conditions and the following disclaimer.
12 # * Redistributions in binary form must reproduce the above copyright
13 # notice, this list of conditions and the following disclaimer in the
14 # documentation and/or other materials provided with the distribution.
16 # * Neither the name of Red Hat nor the names of its contributors may be
17 # used to endorse or promote products derived from this software without
18 # specific prior written permission.
20 # THIS SOFTWARE IS PROVIDED BY RED HAT AND CONTRIBUTORS ''AS IS'' AND
21 # ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
22 # THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
23 # PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL RED HAT OR
24 # CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
25 # SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
26 # LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
27 # USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
28 # ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
29 # OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
30 # OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
31 # SUCH DAMAGE.
33 # This test is similar to test-retry.sh but it also tests the case
34 # where the reopen operation fails.
36 source ./functions.sh
37 set -e
38 set -x
40 fail=0
42 requires_plugin sh
43 requires qemu-io --version
44 requires dd iflag=count_bytes </dev/null
46 files="retry-reopen-fail-count retry-reopen-fail-open-count
47 retry-reopen-fail-status"
48 rm -f $files
49 cleanup_fn rm -f $files
51 # do_test retries mintime expcount status
52 do_test ()
54 retries=$1
55 mintime=$2
56 expcount=$3
57 status=$4
59 echo 0 > retry-reopen-fail-count
60 echo 0 > retry-reopen-fail-open-count
61 : > retry-reopen-fail-status
62 start_t=$SECONDS
64 # Create a custom plugin which will test retrying.
65 nbdkit -v -U - \
66 sh - \
67 --filter=retry retry-delay=1 retries=$retries \
68 --run 'qemu-io -r -f raw $nbd -c "r 0 512" -c "r 0 512"
69 echo $? >> retry-reopen-fail-status' <<'EOF'
70 #!/usr/bin/env bash
71 handle=$2
72 check_handle () {
73 if [ x"$handle" != xhandle ]; then
74 echo 22 >> retry-reopen-fail-status
75 exit 22
78 case "$1" in
79 open)
80 # Count how many times the connection is (re-)opened.
81 read i < retry-reopen-fail-open-count
82 ((i++))
83 echo $i > retry-reopen-fail-open-count
84 if [ $i -eq 2 ]; then
85 echo "EIO open failed" >&2
86 exit 1
88 echo "handle"
90 pread)
91 check_handle
92 # Fail 2 times then succeed.
93 read i < retry-reopen-fail-count
94 ((i++))
95 echo $i > retry-reopen-fail-count
96 if [ $i -le 2 ]; then
97 echo "EIO pread failed" >&2
98 exit 1
99 else
100 dd if=/dev/zero count=$3 iflag=count_bytes
104 get_size)
105 check_handle
106 echo 512 ;;
107 *) exit 2 ;;
108 esac
111 # Check that running time appears reasonable.
112 end_t=$SECONDS
113 if [ $((end_t - start_t)) -lt $mintime ]; then
114 echo "$0: test ran too quickly"
115 fail=1
118 # Check the handle was opened as often as expected.
119 read open_count < retry-reopen-fail-open-count
120 if [ $open_count -ne $expcount ]; then
121 echo "$0: open-count ($open_count) != $expcount"
122 fail=1
125 # Check the exit status of qemu-io
126 read qemu_status < retry-reopen-fail-status
127 if [ $qemu_status -ne $status ]; then
128 echo "$0: status ($qemu_status) != $status"
129 fail=1
133 # In this first test we should see 3 failures:
134 # first pread FAILS
135 # retry and wait 1 seconds
136 # open FAILS
137 # retry and wait 2 seconds
138 # open succeeds
139 # first pread FAILS
140 # retry and wait 4 seconds
141 # open succeeds
142 # first pread succeeds
143 # second pread succeeds
145 # The minimum time for the test should be 1+2+4 = 7 seconds.
146 do_test 5 7 4 0
148 # In this second test we should see the following:
149 # first pread FAILS
150 # retry and wait 1 seconds
151 # open FAILS, ending first pread in failure
152 # first pread FAILS
153 # second pread requires open
154 # open succeeds
155 # second pread FAILS
156 # retry and wait 1 seconds
157 # open succeeds
158 # second pread succeeds
160 # The minimum time for the test should be 1+1 = 2 seconds.
161 do_test 1 2 3 1
163 exit $fail